Subject: bug#19468: 25.0.50; UI inconveniences with M-.

From: Eli Zaretskii <[email-masked]>
Date: Tue, 28 Apr 2015 17:50:55 +0300

> Date: Tue, 28 Apr 2015 01:15:16 +0300
> From: Dmitry Gutov <[email-masked]>
> CC: [email-masked]
> 
>     I certainly hope that at least the Semantic one materializes soon
>     enough, otherwise it sounds like all this move to xref was for the
>     benefit of unbundled packages, and users of Emacs are just punished by
>     having to learn a new UI for no real advantage.
> 
> It's probably up to CEDET developers.

I hope they are reading this.  (Personally, I'd expect the back-ends
for at least the most popular languages be ready before the switch to
the new API and the new UI, but that's me.)

> But the UI itself is one of the benefits. If the old one was considered superior, the new API could have been introduced without really changing the UI.

I didn't ask for the old UI; I can still have it if I want it.  This
bug report is about improving the new UI.

>                 . The doc string of xref-find-function mentions several variants of
>                   invoking the function, but there doesn't seem to be any way of
>                   controlling that when invoking the function interactively, is
>                   there?  I think it would be good to be able to lookup only the
>                   definitions or only the references of a symbol.
> 
> There seems some confusion here: you do now invoke xref-find-function. It's not a function anyway, it's a variable, which different backends can set to implement the backend interface.

Then the confusion is the doc string's fault: it should make this
aspect clear.  And if there are no back-ends currently that support
these options, I'd suggest to remove that from the doc string -- we
shouldn't advertise in the docs stuff that no one implemented.

>     Not from me: I've been told in this discussion that I don't understand
>     the new UI, don't appreciate its many virtues, and generally am no
>     more than an obstacle on the way of progress.
> 
> I really don't remember stating that in this discussion.

Indeed, you didn't.  But you are not alone in this discussion.